# AUTOGENERATED! DO NOT EDIT! File to edit: 10_utils_bamfilter.ipynb (unless otherwise specified).

__all__ = ['filter_bam_by_name']

# Cell

import pysam

# Cell

def filter_bam_by_name(read_name_list,bamfile,output,*,included=True):
    '''
    Filter the bam by read name

    :param str read_name_list: read name list, could be names include or exclude
    :param str bamfile: bam
    :param str output: output bam file
    :param bool included: whether the read names in the read name list should be included in the output bamfile or excluded in the output bamfile

    '''
    with open(read_name_list,'r') as f:
        name_list = f.read()
    n=0
    with pysam.AlignmentFile(bamfile,'rb') as inbam, pysam.AlignmentFile(output,'wb',template=inbam) as outbam:
        for read in inbam.fetch():
            n+=1
            if n% 10000 ==0:
                print(f'Working on the {n} reads')
            if included:
                if read.query_name in name_list:
                    outbam.write(read)
            else:
                if read.query_name not in name_list:
                    outbam.write(read)
